
'     ( RC5)
' v 1.1
':  
'   :     
'      5   30 
'   89%

$crystal = 4000000                                          '  ZQ1, 
$regfile = "ATtiny2313.dat"                                 '  
$lib "mcsbyte.lbx"                                          '  
Config Rc5 = Pinb.2                                         'PD0 -  RC-5
Config Pinb.4 = Output                                      '
Config Pinb.6 = Output                                      '
Config Pind.0 = Output                                      '
Config Pind.2 = Input                                       '
Config Pind.5 = Input                                       '

Dim Address As Byte                                         ' 
Dim Command As Byte
Dim A As Integer
Dim B As Byte

Enable Interrupts                                           ' 

For A = 1 To 5
Set Portb.4 : Set Portb.6
Waitms 500
Reset Portb.4 : Reset Portb.6
Waitms 500
Next A
Reset Portd.0
Set Portb.4

1:                                                          '  
Do
Debounce Pind.2 , 0 , Kntimer                               '
Debounce Pind.5 , 0 , Kn2                                   '
Getrc5(address , Command)
If Address = 0 Then
 Command = Command And &B01111111

 If Command = 32 Then                                       ' ( P+)
   Reset Portb.4                                            ' 
   Set Portd.0
   Set Portb.6
  End If

 If Command = 33 Then                                       ' ( P-)
   Set Portb.4
   Reset Portd.0
   Reset Portb.6                                            ' 
  End If

 If Command = 1 Then                                        ' ( 1)
   Gosub Hl1                                                ' 
   Goto T1                                                  '  5 
  End If

 If Command = 2 Then                                        ' ( 2)
   Gosub Hl1                                                ' 
   Goto T2                                                  '  10 
  End If

 If Command = 3 Then                                        ' ( 3)
   Gosub Hl1                                                ' 
   Goto T3                                                  '  20 
  End If

 If Command = 4 Then                                        ' ( 4)
   Gosub Hl1                                                ' 
   Goto T4                                                  '  30 
  End If

 If Command = 5 Then                                        ' ( 5)
   Gosub Hl1                                                ' 
   Goto T5                                                  '  45 
  End If

  If Command = 6 Then                                       ' ( 6)
   Gosub Hl1                                                ' 
   Goto T6                                                  '  60 
  End If

End If
Loop
'------------------------   5  ------------------------------------
T1:
Set Portd.0
Set Portb.4
For A = 0 To 1800 Step 1
'Debounce Pind.5 , 0 , Kn3
'Getrc5(address , Command)
'If Address = 0 Then
' Command = Command And &B01111111

'  If Command = 33 Then                                      ' ( P-)
'   Gosub Hl1                                     ' 
'   Goto 1
'  End If
'End If
Gosub Timeroff
Waitms 27                                                   'Waitms 27  A=60  10 
Next A
  For B = 1 To 4 Step 1
   Reset Portb.6
   Waitms 500
   Set Portb.6
   Waitms 500
  Next B

   Set Portb.4
   Reset Portd.0
   Reset Portb.6
Goto 1
'------------------------   10  -----------------------------------
T2:
Set Portd.0
Set Portb.4
For A = 0 To 3600 Step 1
Gosub Timeroff                                              ' 
Waitms 27                                                   'Waitms 27  A=60  10 
Next A
   For B = 1 To 4 Step 1
   Reset Portb.6
   Waitms 500
   Set Portb.6
   Waitms 500
  Next B

   Set Portb.4
   Reset Portd.0
   Reset Portb.6
Goto 1
'------------------------   20  -----------------------------------
T3:
Set Portb.4
Set Portd.0
For A = 0 To 7200 Step 1
Gosub Timeroff
Waitms 27                                                   'Waitms 27  A=60  10 
Next A
   For B = 1 To 4 Step 1
   Reset Portb.6
   Waitms 500
   Set Portb.6
   Waitms 500
  Next B

   Set Portb.4
   Reset Portd.0
   Reset Portb.6
Goto 1
'------------------------   30  -----------------------------------
T4:
Set Portb.4
Set Portd.0
For A = 0 To 10800 Step 1                                   '10800
Gosub Timeroff
Waitms 27                                                   'Waitms 27  A=60  10 
Next A
   For B = 1 To 4 Step 1
   Reset Portb.6
   Waitms 500
   Set Portb.6
   Waitms 500
  Next B

   Set Portb.4
   Reset Portd.0
   Reset Portb.6
Goto 1
'------------------------   45  -----------------------------------
T5:
Set Portb.4
Set Portd.0
For A = 0 To 16200 Step 1
Gosub Timeroff
Waitms 27                                                   'Waitms 27  A=60  10 
Next A
   For B = 1 To 4 Step 1
   Reset Portb.6
   Waitms 500
   Set Portb.6
   Waitms 500
  Next B

   Set Portb.4
   Reset Portd.0
   Reset Portb.6
Goto 1
'------------------------   60  -----------------------------------
T6:
Set Portb.4
Set Portd.0
For A = 0 To 21600 Step 1
Gosub Timeroff
Waitms 27                                                   'Waitms 27  A=60  10 
Next A
   For B = 1 To 4 Step 1
   Reset Portb.6
   Waitms 500
   Set Portb.6
   Waitms 500
  Next B

   Set Portb.4
   Reset Portd.0
   Reset Portb.6
Goto 1
'-----------------------------   -----------------------------------
Timeroff:                                                   '
Debounce Pind.5 , 0 , Kn3
Getrc5(address , Command)
If Address = 0 Then
 Command = Command And &B01111111

  If Command = 33 Then                                      ' ( P-)
   Reset Portb.4
   Set Portb.6
   Waitms 500
   Goto 1
  End If
End If
Return
'--------------------------------   -----------------------------
Hl1:                                                        '
Reset Portb.4                                               ' 
   Set Portd.0
   Set Portb.6
Return
'----------------------------   ------------------------------------
Kn1:                                                        ' 
   Reset Portb.4                                            ' 
   Set Portd.0
   Set Portb.6
Goto 1
'--------       5  ------------------
Kntimer:
   Reset Portb.4                                            '  
   Set Portd.0                                              ' 
   Set Portb.6
For A = 1 To 55 Step 1
Debounce Pind.2 , 1 , Kn1                                   '   
Waitms 20
Next A
Goto Settimer                                               '    
'-------------------------   --------------------------------------
Kn2:
   Set Portb.4
   Reset Portd.0
   Reset Portb.6
Goto 1
'------------      5  -----------------
Settimer:
Reset Portb.6
Waitms 300
Set Portb.6
Waitms 300
Reset Portb.6
Waitms 300
Set Portb.6
Waitms 300

For B = 1 To 60 Step 1                                      '   30    
Waitms 200                                                  '    
Set Portb.4
Debounce Pind.2 , 0 , Kntimer2                              ' T1   5 
Gosub Timeroff                                              ' 
Waitms 200
Reset Portb.4
Next B
Goto 1
'--------       30  -----------------
Kntimer2:
For A = 1 To 55 Step 1
Debounce Pind.2 , 1 , T1                                    '      5 
Waitms 20
Next A
Goto Settimer2
'------------      30  ----------------
Settimer2:
Reset Portb.6
Waitms 300
Set Portb.6
Waitms 300
Reset Portb.6
Waitms 300
Set Portb.6
Waitms 300

For B = 1 To 60 Step 1
Waitms 200
Set Portb.4
Debounce Pind.2 , 0 , T4                                    '  30 
Gosub Timeroff                                              ' 
Waitms 200
Reset Portb.4
Next B                                                      'Loop
Goto 1


'--------------------------   --------------------------------------

Kn3:                                                        '
   Reset Portb.4
   Set Portb.6
   Waitms 500
Goto 1



End                                                         '  